unit MainWnd;
{
 * NokomoDecoder
 * Copyright (c) 2005 Autch.net. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 
 *     Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 
 *     Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * 
 *     Neither the name of the Autch.net nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
}

interface

uses
	Windows, SysUtils, Controls, Forms,	Dialogs, MMSystem, kpiWrapper, KPI,
	kpiDriver, KpiSong, ImgList, kpiFileDecoderThread, Spin, StdCtrls, ExtCtrls,
	ComCtrls, Classes, SplashWnd, Menus, ToolWin, kpiPlayListReader, Strutils;

type

  // WXgɂĂfR[hݒ
	TDecodeSettings = record
		SamplesPerSec, BitsPerSample, Channels, DefaultLength, FadeOutLength: DWord;
		IgnoreSongLength: Boolean;
	end;

  // UI R[hWbNSꏏorz
	TfrmMain = class(TForm)
		pgDecodeMode: TPageControl;
		tbsSingleFile: TTabSheet;
		tbsMultipleFiles: TTabSheet;
		splSplitter: TSplitter;
		lbeSourceFile: TLabeledEdit;
		btnBrowse: TButton;
		lbePCMFile: TLabeledEdit;
		btnBrowsePCM: TButton;
		imlIcons: TImageList;
		lstLog: TListBox;
		pbrDecodeProgress: TProgressBar;
		btnSingleDecode: TButton;
		lblProgress: TLabel;
		tbsSettings: TTabSheet;
		dlgSave: TSaveDialog;
		dlgOpen: TOpenDialog;
		speSongNum: TSpinEdit;
		Label1: TLabel;
		tabAbout: TTabSheet;
		Label2: TLabel;
		Bevel1: TBevel;
		lblVersion: TLabel;
		Memo1: TMemo;
		lvwDecodeSettings: TListView;
		pnlSettingsContainer: TPanel;
		grpModifySetting: TGroupBox;
		speSamplingFrequency: TSpinEdit;
    lblSamplingFrequency: TLabel;
		cmbSampleFormat: TComboBox;
		lblQuantizeBits: TLabel;
		speChannels: TSpinEdit;
		lblChannels: TLabel;
		Label3: TLabel;
		speDefaultLength: TSpinEdit;
		Label4: TLabel;
		btnAddSetting: TButton;
		btnDeleteSetting: TButton;
		Label5: TLabel;
		cmbPCMFormat: TComboBox;
		lblAutchWeb: TLabel;
		lblEmail: TLabel;
		btnRenameSetting: TButton;
		Label6: TLabel;
		speFadeoutLength: TSpinEdit;
    pmnuLog: TPopupMenu;
    mnuCopyLogEntry: TMenuItem;
		mnuSaveLogs: TMenuItem;
    mnuMain: TMainMenu;
    mnuOptions: TMenuItem;
    mnuConfigure: TMenuItem;
    Label7: TLabel;
    lbeKbmFile: TLabeledEdit;
    btnBrowseForKbm: TButton;
    Label10: TLabel;
    btnStartMultiDecode: TButton;
    cmbPcmFormatForMulti: TComboBox;
    pbrIndivProgress: TProgressBar;
    lblIndivProgress: TLabel;
		procedure FormDestroy(Sender: TObject);
		procedure lstLogDrawItem(Control: TWinControl; Index: Integer;
			Rect: TRect; State: TOwnerDrawState);
		procedure FormCreate(Sender: TObject);
		procedure btnBrowseClick(Sender: TObject);
		procedure btnBrowsePCMClick(Sender: TObject);
		procedure btnSingleDecodeClick(Sender: TObject);
		procedure btnAddSettingClick(Sender: TObject);
		procedure btnDeleteSettingClick(Sender: TObject);
		procedure lvwDecodeSettingsSelectItem(Sender: TObject; Item: TListItem;
			Selected: Boolean);
		procedure lvwDecodeSettingsClick(Sender: TObject);
		procedure speSamplingFrequencyChange(Sender: TObject);
		procedure speChannelsChange(Sender: TObject);
		procedure speDefaultLengthChange(Sender: TObject);
		procedure cmbSampleFormatChange(Sender: TObject);
		procedure lvwDecodeSettingsChange(Sender: TObject; Item: TListItem;
			Change: TItemChange);
		procedure lblAutchWebClick(Sender: TObject);
		procedure btnRenameSettingClick(Sender: TObject);
		procedure speFadeoutLengthChange(Sender: TObject);
		procedure mnuSaveLogsClick(Sender: TObject);
		procedure mnuCopyLogEntryClick(Sender: TObject);
		procedure lstLogKeyDown(Sender: TObject; var Key: Word;
			Shift: TShiftState);
    procedure btnBrowseForKbmClick(Sender: TObject);
    procedure btnStartMultiDecodeClick(Sender: TObject);
	private
		Driver: TAuKpiDriver;
		SingleDecoder: TAuKpiFileDecoderThread;
		SplashWnd: TfrmSplash;
    m_bMultiDecoderTerminated, m_bMDAborted: boolean;

		function OnLoadPlugin(Plugin: TAuKpi): Boolean;
		function GetImgIndexByText(S: PChar): Integer;
		procedure OnSingleDecoderProgress(Song: TAuSong);
		procedure OnSingleDecoderTerminate(Sender: TObject);
		procedure OnMultiDecoderProgress(Song: TAuSong);
		procedure OnMultiDecoderTerminate(Sender: TObject);
		procedure AddLog(const msg: string);
		procedure RefreshSettingGroup(Item: TListItem);
		procedure RefreshPCMFormatComboBox;
		procedure ChangeSettingGroupEnabled(const value: Boolean);
		procedure SetSoundProperties(const index: Integer; var sInfo: SOUNDINFO);
		procedure OnPluginLoadFailed(const FileName: TFileName);
		function IndexToSettings(const Index: integer): TDecodeSettings;
		procedure SaveDecodeSettings;
		procedure LoadDecodeSettings;
	public
		{ Public 錾 }
	end;

var
	frmMain: TfrmMain;

implementation

uses KbMPath, Version, ShellAPI, kpiEffector, KbMD_Common, Clipbrd, Registry;

{$R *.dfm}

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
	Driver.Free;
	SaveDecodeSettings;
end;

function TfrmMain.OnLoadPlugin(Plugin: TAuKpi): Boolean;
begin
	AddLog(Format('  %s ver.%d [h܂', [ExtractFileName(Plugin.FileName), Plugin.PluginVersion]));
	SplashWnd.fraSplash1.lblStatus.Caption := Format('  %s ver.%d [h܂', [ExtractFileName(Plugin.FileName), Plugin.PluginVersion]);

	Application.ProcessMessages;
	Result := true;
end;

// I[i[`FbZ[W̃ACR`
procedure TfrmMain.lstLogDrawItem(Control: TWinControl; Index: Integer;
	Rect: TRect; State: TOwnerDrawState);
var
	bmpOffset: Integer;		{ rbg}bṽItZbg }
	Offset: Integer;			{ ̃ItZbg }
	imgIndex: Integer;
begin
	with (Control as TListBox).Canvas do	{ Rg[̃LoXɕ`itH[ł͂Ȃj }
	begin
		FillRect(Rect);					{ `NA }
		bmpOffset := 2;					{ ftHg̃ItZbg }
		Offset := bmpOffset + 16 + 4;

		imgIndex := GetImgIndexByText(PChar((Control as TListBox).Items[Index]));

		imlIcons.Draw((Control as TListBox).Canvas, Rect.Left + bmpOffset, Rect.Top, imgIndex);
		TextOut(Rect.Left + Offset, Rect.Top + 2, (Control as TListBox).Items[Index])	{ \ }
	end;
end;

// bZ[WeACR߂B߂l ImageList vf̃CfbNX
function TfrmMain.GetImgIndexByText(S: PChar): Integer;
begin
	if (StrPos(S, 'G[') <> nil) then
		// G[
		GetImgIndexByText := 2											 // ߑł
	else if (StrPos(S, 'x') <> nil) then
		// x
		GetImgIndexByText := 1
	else
		// 
		GetImgIndexByText := 0;
end;


procedure TfrmMain.FormCreate(Sender: TObject);
begin

{$IFOPT D+}
	lblVersion.Caption := 'Version ' + theVersion.StringVersion + ' (debug)';
{$ELSE}
	lblVersion.Caption := 'Version ' + theVersion.StringVersion;
{$ENDIF}

	pgDecodeMode.ActivePageIndex := 0;
	pgDecodeMode.Enabled := false;

  // XvbVFvOCǂނ̂ɒԂ̂
	SplashWnd := TfrmSplash.Create(Self);
	SplashWnd.Show;
	try
{$IFOPT D+}
		AddLog(Format('̂ Decoder Version %s fobO', [theVersion.StringVersion]));
{$ELSE}
		AddLog(Format('̂ Decoder Version %s', [theVersion.StringVersion]));
{$ENDIF}

		AddLog('vOC ' + GetPluginPath + ' 烍[h܂');

    // kpi hCõ[h
		Driver := TAuKpiDriver.Create;
		Driver.OnPluginLoadProgress := OnLoadPlugin;
		Driver.OnPluginLoadFailed := OnPluginLoadFailed;
		Driver.AddPlugins(KbMPath.GetPluginPath); // KMP ̃vOCpXȉɂvOC[h
    // l Driver.AddPlugins() 񋓂ΔCӂ̃pX̃vOC[hł

		AddLog(Format('%d ̃vOC[h܂', [Driver.Plugins.Count]));
		SplashWnd.fraSplash1.lblStatus.Caption := Format('%d ̃vOC[h', [Driver.Plugins.Count]);
	finally
		pgDecodeMode.Enabled := true;
		LoadDecodeSettings;
		ChangeSettingGroupEnabled(false);
		RefreshPCMFormatComboBox;
		SplashWnd.Release;
		Show;
		pgDecodeMode.Enabled := true;
	end;
end;

procedure TfrmMain.btnBrowseClick(Sender: TObject);
begin
  dlgOpen.Filter := 'ׂẴI[fBIt@C|*.*';
	if dlgOpen.Execute then
	begin
		lbeSourceFile.Text := dlgOpen.FileName;
		lbePCMFile.Text := ChangeFileExt(dlgOpen.Filename, '.wav');
	end;
end;

procedure TfrmMain.btnBrowsePCMClick(Sender: TObject);
begin
	dlgSave.Filter := 'Wave t@Ci*.wavj|*.wav';
	if dlgSave.Execute then
		lbePCMFile.Text := dlgSave.Filename;
end;

// Pt@C̃fR[h
procedure TfrmMain.btnSingleDecodeClick(Sender: TObject);
var
	theSong: TAuSong;
	sInfo: SOUNDINFO;
	Fader: TAuKpiFader;
	dwFadeOutStart: DWord;
	Settings: TDecodeSettings;
begin
  // fR[hɓ{^ƒ~
	if btnSingleDecode.Caption <> '~(&A)' then
	begin
		try
      btnStartMultiDecode.Enabled := false; // fR[hɃ^u؂ւȁI
      // R{őIꂽfR[hݒǂ
			Settings := IndexToSettings(cmbPCMFormat.ItemIndex);
      //  SOUNDINFO ݒ
			SetSoundProperties(cmbPCMFormat.ItemIndex, sInfo);

      // t@CJ Song 擾
			theSong := Driver.CreateSong(lbeSourceFile.Text, @sInfo);
			if theSong = nil then
				raise Exception.CreateFmt('G[: t@C %s ɓKvOC܂ł', [lbeSourceFile.Text]);
			AddLog('t@C ' + lbeSourceFile.Text + ' ̃fR[hJn܂');
			with theSong do
			begin
				AddLog('  vOC ' + ExtractFileName(PluginFileName) + ' gp܂');
				AddLog(Format('  %dHz, %d rbg, %d `l', [SamplesPerSec, BitsPerSample, Channels]));

        // JȂĂ邶
				if SamplesPerSec * BitsPerSample * Channels = 0 then
					raise Exception.Create('G[: PCM p[^ُł');

        // t@CȂ̋Ȕԍ`FbN
				if theSong.MultiSong = true then
				begin
					if (theSong.Length div 1000) < Cardinal(speSongNum.Value) then
						raise Exception.CreateFmt('G[: Ȕԍ %d ͔͈͊Oł', [speSongNum.Value]);
					theSong.SongNumber := speSongNum.Value;
				end;

        // fR[hXbh쐬
				SingleDecoder := TAuKpiFileDecoderThread.Create(theSong, lbePCMFile.Text);

				btnSingleDecode.Caption := '~(&A)';

        // tF[hAEgKvAKvȂ牽 ms ڂtF[hAEgn߂邩
				dwFadeOutStart := Length;
				if (Length < $ffffffff) and (MultiSong = false) then
					pbrDecodeProgress.Max := Length
				else if (Length = $ffffffff) or MultiSong then
				begin
					pbrDecodeProgress.Max := Settings.DefaultLength * 1000 + Settings.FadeOutLength;
					dwFadeOutStart := Settings.DefaultLength * 1000;
				end;

        // tF[hAEgKvȂAtF[_NX𐶐
				if (Length < $ffffffff) and (MultiSong = false) and (Loop = false) then
					Fader := nil
				else
					Fader := TAuKpiFader.Create(dwFadeOutStart, Settings.FadeOutLength);

				with SingleDecoder do
				begin
					FreeOnTerminate := true;
					if Assigned(Fader) then Effectors.Add(Fader);
          //Effectors.Add(TAuKpiDigitalEmphasis.Create());@// ܂
					OnProgress := OnSingleDecoderProgress;
					OnTerminate := OnSingleDecoderTerminate;
					Title := '';
					Artist := '';

          // fR[hJn
					Resume;
				end;
			end;
		except
			on E: Exception do
			begin
				AddLog(E.Message);
				AddLog('x: fR[h͎s܂');
        btnStartMultiDecode.Enabled := true;
			end;
		end;
	end
	else
	begin
		SingleDecoder.Terminate;
		btnSingleDecode.Caption := 'Jn(&S)';
		AddLog('  x: fR[h̓[U̎wɂ蒆~܂');
		AddLog('  x: t@C͍폜܂');
    btnStartMultiDecode.Enabled := true;
	end;
end;

procedure TfrmMain.OnSingleDecoderProgress(Song: TAuSong);
	function MSecsToString(const mSecs: DWord): string;
	begin
		Result := Format('%.2d:%.2d.%.3d', [(mSecs div 60000), (mSecs div 1000) mod 60, mSecs mod 1000]);
	end;
begin
	pbrDecodeProgress.Position := Song.Position;
	lblProgress.Caption := Format('%s / %s', [MSecsToString(Song.Position), MSecsToString(pbrDecodeProgress.Max)]);
end;

procedure TfrmMain.OnSingleDecoderTerminate(Sender: TObject);
begin
	pbrDecodeProgress.Position := 0;
	btnSingleDecode.Caption := 'Jn(&S)';
	AddLog('fR[h͊܂');
end;

// bZ[WOɒǉ
procedure TfrmMain.AddLog(const msg: string);
begin
	lstLog.AddItem(msg, nil);
	lstLog.TopIndex := lstLog.Items.Count - 1;
	lstLog.ItemIndex := lstLog.Items.Count - 1;
	LogFile.Add(msg);
end;

// uVfR[hݒv{^
procedure TfrmMain.btnAddSettingClick(Sender: TObject);
var
	theItem: TListItem;
begin
	theItem := lvwDecodeSettings.Items.Add;
	with theItem do
	begin
		Caption := 'Vݒ';
		SubItems.Add('44100');
		SubItems.Add('16');
		SubItems.Add('2');
		SubItems.Add('120');
		SubItems.Add('5000');
	end;
	lvwDecodeSettings.Selected := theItem;
	theItem.MakeVisible(true);
	theItem.EditCaption;
end;

// ũfR[hݒ폜v{^
procedure TfrmMain.btnDeleteSettingClick(Sender: TObject);
begin
	with lvwDecodeSettings do
		if Assigned(Selected) then
			Items.Delete(Items.IndexOf(Selected));
	btnDeleteSetting.Enabled := false;
	btnRenameSetting.Enabled := false;
	ChangeSettingGroupEnabled(false);
	RefreshPCMFormatComboBox;
end;

procedure TfrmMain.lvwDecodeSettingsSelectItem(Sender: TObject;
	Item: TListItem; Selected: Boolean);
begin
	btnRenameSetting.Enabled := true;
	btnDeleteSetting.Enabled := true;
	RefreshSettingGroup(Item);
end;

// fR[hݒҏW邽߂ɃRg[XV
procedure TfrmMain.RefreshSettingGroup(Item: TListItem);
begin
	grpModifySetting.Caption := Item.Caption + ' ̐ݒ';
	speSamplingFrequency.Value := StrToIntDef(Item.SubItems[0], 44100);
	speChannels.Value := StrToIntDef(Item.SubItems[2], 2);
	speDefaultLength.Value := StrToIntDef(Item.SubItems[3], 120);
	speFadeOutLength.Value := StrToIntDef(Item.SubItems[4], 5000);
	cmbSampleFormat.ItemIndex := cmbSampleFormat.Items.IndexOf(Item.SubItems[1]);
	ChangeSettingGroupEnabled(true);
end;

procedure TfrmMain.lvwDecodeSettingsClick(Sender: TObject);
begin
	if not Assigned(lvwDecodeSettings.Selected) then
	begin
		ChangeSettingGroupEnabled(false);
		btnDeleteSetting.Enabled := false;
		btnRenameSetting.Enabled := false;
	end;
end;

procedure TfrmMain.speSamplingFrequencyChange(Sender: TObject);
begin
	if Assigned(lvwDecodeSettings.Selected) and (speSamplingFrequency.Text <> '') then
		lvwDecodeSettings.Selected.SubItems[0] := IntToStr(speSamplingFrequency.Value);
end;

procedure TfrmMain.speChannelsChange(Sender: TObject);
begin
	if Assigned(lvwDecodeSettings.Selected) and (speChannels.Text <> '') then
		lvwDecodeSettings.Selected.SubItems[2] := IntToStr(speChannels.Value);
end;

procedure TfrmMain.speDefaultLengthChange(Sender: TObject);
begin
	if Assigned(lvwDecodeSettings.Selected) and (speDefaultLength.Text <> '') then
		lvwDecodeSettings.Selected.SubItems[3] := IntToStr(speDefaultLength.Value);
end;

procedure TfrmMain.cmbSampleFormatChange(Sender: TObject);
begin
	if Assigned(lvwDecodeSettings.Selected) then
		lvwDecodeSettings.Selected.SubItems[1] := cmbSampleFormat.Text;
end;

procedure TfrmMain.RefreshPCMFormatComboBox;
  procedure AddEntries(cmb: TComboBox);
  var
    i: integer;
  begin
    with cmb do
    begin
  		Items.BeginUpdate;
	  	try
		  	Clear;
			  for i := 0 to lvwDecodeSettings.Items.Count - 1 do
				  AddItem(lvwDecodeSettings.Items[i].Caption, nil);
  		finally
	  		Items.EndUpdate;
		  	ItemIndex := 0;
  		end;
    end;
  end;
begin
  AddEntries(cmbPcmFormat);
  AddEntries(cmbPcmFormatForMulti);
end;

procedure TfrmMain.lvwDecodeSettingsChange(Sender: TObject;
  Item: TListItem; Change: TItemChange);
begin
	if (Change = ctText) and (Item.SubItems.Count = 4) then
	begin
		RefreshSettingGroup(Item);
		RefreshPCMFormatComboBox;
	end;
	RefreshPCMFormatComboBox;
end;

procedure TfrmMain.ChangeSettingGroupEnabled(const value: Boolean);
var
	i: integer;
begin
	for i := 0 to grpModifySetting.ControlCount - 1 do
		grpModifySetting.Controls[i].Enabled := value;
	grpModifySetting.Enabled := value;
end;

procedure TfrmMain.lblAutchWebClick(Sender: TObject);
begin
	ShellExecute(Handle, nil, PChar((Sender as TLabel).Caption), nil, nil, 0);
end;

// ufR[hݒ胊XgṽCfbNX SOUNDINFO ݒ
procedure TfrmMain.SetSoundProperties(const index: Integer; var sInfo: SOUNDINFO);
begin
	ZeroMemory(@sInfo, SizeOf(SOUNDINFO));

	sInfo.dwSamplesPerSec := StrToInt(lvwDecodeSettings.Items[index].SubItems[0]);
	sInfo.dwChannels := StrToInt(lvwDecodeSettings.Items[index].SubItems[2]);
	case cmbSampleFormat.Items.IndexOf(lvwDecodeSettings.Items[index].SubItems[1]) of
		0:	sInfo.dwBitsPerSample := 0;					// default
		1:	sInfo.dwBitsPerSample := 16;				// 16bit int
		2:	sInfo.dwBitsPerSample := 24;				// 24bit int
		3:	sInfo.dwBitsPerSample := 32;				// 32bit int
	end;
end;

procedure TfrmMain.btnRenameSettingClick(Sender: TObject);
begin
	with lvwDecodeSettings do
		if Assigned(Selected) then
			Selected.EditCaption;
end;

procedure TfrmMain.OnPluginLoadFailed(const FileName: TFileName);
begin
	AddLog(Format('  x: %s ̃[hɎs܂', [FileName]));
	SplashWnd.fraSplash1.lblStatus.Caption := Format('  x: %s ̃[hɎs܂', [FileName]);
	Application.ProcessMessages;
end;

procedure TfrmMain.speFadeoutLengthChange(Sender: TObject);
begin
	if Assigned(lvwDecodeSettings.Selected) and (speFadeOutLength.Text <> '') then
		lvwDecodeSettings.Selected.SubItems[4] := IntToStr(speFadeOutLength.Value);
end;

procedure TfrmMain.mnuSaveLogsClick(Sender: TObject);
begin
	dlgSave.Filter := 'Ot@Ci*.logj|*.log|ׂẴt@C|*.*';
	if dlgSave.Execute then
		LogFile.SaveToFile(dlgSave.FileName);
end;

procedure TfrmMain.mnuCopyLogEntryClick(Sender: TObject);
begin
	Clipboard.Clear;
	Clipboard.AsText := lstLog.Items[lstLog.ItemIndex];
end;

procedure TfrmMain.lstLogKeyDown(Sender: TObject; var Key: Word;
	Shift: TShiftState);
begin
	if (Key = Ord('S')) and (ssCtrl in Shift) then
		mnuSaveLogsClick(Sender);
	if (Key = Ord('C')) and (ssCtrl in Shift) then
		mnuCopyLogEntryClick(Sender);
end;

function TfrmMain.IndexToSettings(const Index: integer): TDecodeSettings;
begin
	with Result do
	begin
		SamplesPerSec := StrToInt(lvwDecodeSettings.Items[index].SubItems[0]);
		Channels := StrToInt(lvwDecodeSettings.Items[index].SubItems[2]);
		case cmbSampleFormat.Items.IndexOf(lvwDecodeSettings.Items[index].SubItems[1]) of
			0:	BitsPerSample := 0;					// default
			1:	BitsPerSample := 16;				// 16bit int
			2:	BitsPerSample := 24;				// 24bit int
			3:	BitsPerSample := 32;				// 32bit int
		end;
		DefaultLength := StrToInt(lvwDecodeSettings.Items[Index].SubItems[3]);
		FadeOutLength := StrToInt(lvwDecodeSettings.Items[Index].SubItems[4]);
	end;
end;

procedure TfrmMain.SaveDecodeSettings;
var
	i: integer;
	RegSettings: TRegistry;
	theItem: TListItem;
begin
	RegSettings := TRegistry.Create;
	try
		RegSettings.RootKey := HKEY_CURRENT_USER;
		if RegSettings.OpenKey(Format('\%s', [RegEntryName]), false) then
		begin
			// Ƒ댯Ȏi
			RegSettings.DeleteKey('DecodeSettings');
			RegSettings.CloseKey;
		end;

		for i := 0 to lvwDecodeSettings.Items.Count - 1 do
		begin
			theItem := lvwDecodeSettings.Items[i];

			RegSettings.RootKey := HKEY_CURRENT_USER;
			if RegSettings.OpenKey(Format('\%s\DecodeSettings\%s', [RegEntryName, theItem.Caption]), true) then
			begin
				RegSettings.WriteInteger('SamplingFrequency', StrToInt(theItem.SubItems[0]));
				RegSettings.WriteInteger('BitsPerSample', StrToIntDef(theItem.SubItems[1], 0));
				RegSettings.WriteInteger('Channels', StrToInt(theItem.SubItems[2]));
				RegSettings.WriteInteger('DefaultLength', StrToInt(theItem.SubItems[3]));
				RegSettings.WriteInteger('FadeoutLength', StrToInt(theItem.SubItems[4]));

				RegSettings.CloseKey;
			end;
		end;
	finally
		RegSettings.Free;
	end;
end;

procedure TfrmMain.LoadDecodeSettings;
var
	RegSettings: TRegistry;
	SubKeys: TStrings;
	i: integer;
	theItem: TListItem;
begin
	RegSettings := TRegistry.Create;
	SubKeys := TStringList.Create;
	try
		RegSettings.RootKey := HKEY_CURRENT_USER;
		if RegSettings.OpenKeyReadOnly(Format('\%s\DecodeSettings', [RegEntryName])) then
		begin
			lvwDecodeSettings.Items.Clear;
			RegSettings.GetKeyNames(SubKeys);
			RegSettings.CloseKey;
			for i := 0 to SubKeys.Count - 1 do
			begin
				if RegSettings.OpenKeyReadOnly(Format('\%s\DecodeSettings\%s', [RegEntryName, SubKeys[i]])) then
				begin
					theItem := lvwDecodeSettings.Items.Add;
					theItem.Caption := SubKeys[i];
					with theItem.SubItems do
					begin
						Add(IntToStr(RegSettings.ReadInteger('SamplingFrequency')));
						if RegSettings.ReadInteger('BitsPerSample') = 0 then
							Add(cmbSampleFormat.Items[0])
						else
							Add(IntToStr(RegSettings.ReadInteger('BitsPerSample')));
						Add(IntToStr(RegSettings.ReadInteger('Channels')));
						Add(IntToStr(RegSettings.ReadInteger('DefaultLength')));
						Add(IntToStr(RegSettings.ReadInteger('FadeoutLength')));
					end;

					RegSettings.CloseKey;
				end;
			end;
		end;
	finally
		SubKeys.Free;
		RegSettings.Free;
	end;
end;

procedure TfrmMain.btnBrowseForKbmClick(Sender: TObject);
begin
  dlgOpen.Filter := 'KBM `vCXgt@C|*.kbm';
	if dlgOpen.Execute then
		lbeKbmFile.Text := dlgOpen.FileName;
end;

// ut@C̃fR[hv- قƂǒP̂ƂRsy
procedure TfrmMain.btnStartMultiDecodeClick(Sender: TObject);
var
  kbmReader: TAuKbmPlayListReader;
  kbmEntry: TAuKbmPlayListEntry;

 	theSong: TAuSong;
	sInfo: SOUNDINFO;
	Fader: TAuKpiFader;
	dwFadeOutStart: DWord;
	Settings: TDecodeSettings;

  dwSongNum: DWord;
  sRealFileName: string;
  sPcmFile: string;
  p: integer;
begin
 	if btnStartMultiDecode.Caption <> '~(&A)' then
	begin
    if lbeKbmFile.Text = '' then Exit;
		Settings := IndexToSettings(cmbPcmFormatForMulti.ItemIndex);
		SetSoundProperties(cmbPcmFormatForMulti.ItemIndex, sInfo);

    try
      // vCXgǂňȕ̃fR[h𒊏o
      kbmReader := TAuKbmPlayListReader.Create(lbeKbmFile.Text);
      try
       	AddLog('ꊇfR[hJn܂');
        btnSingleDecode.Enabled := false;
    		btnStartMultiDecode.Caption := '~(&A)';
        while not kbmReader.IsEOF do
        begin
          // ȕ̃fR[h
          kbmEntry := kbmReader.GetEntry;
          // Ńt@C̃`FbN
          if kbmEntry.sNameInArchive <> '' then
          begin
            AddLog('xFɃt@C ' + kbmEntry.sFileName + ' ̓T|[gĂ܂BXLbv܂B');
            Continue;
          end;
          if (Pos('::AudioCD::', kbmEntry.sFileName) > 0) then
          begin
            AddLog('xFCD-DA ̓T|[gĂ܂BXLbv܂B');
            Continue;
          end;

          sRealFileName := kbmEntry.sFileName;

          // t@CȂ̃`FbN
          p := Pos('::', kbmEntry.sFileName);
          if p > 0 then
          begin
            sRealFileName := LeftStr(sRealFileName, p - 1);
            dwSongNum := StrToInt(Copy(kbmEntry.sFileName, p + 2, Length(kbmEntry.sFileName)));
            sPcmFile := ChangeFileExt(sRealFileName, '') + '[' + Format('%d', [dwSongNum]) + '].wav';
          end
          else
            sPcmFile := ChangeFileExt(sRealFileName, '.wav');

          try
            // t@CJ Song 擾
     			  theSong := Driver.CreateSong(sRealFileName, @sInfo);
 	    		  if theSong = nil then
  	      		raise Exception.CreateFmt('G[: t@C %s ɓKvOC܂ł', [sRealFileName]);

   		    	AddLog('t@C ' + sRealFileName + ' ̃fR[hJn܂');

 	    	  	with theSong do
      		  begin
 	  	  	  	AddLog('  vOC ' + ExtractFileName(PluginFileName) + ' gp܂');
  	      		AddLog(Format('  %dHz, %d rbg, %d `l', [SamplesPerSec, BitsPerSample, Channels]));
	    	    	if SamplesPerSec * BitsPerSample * Channels = 0 then
	  	  	    	raise Exception.Create('G[: PCM p[^ُł');
     				  if theSong.MultiSong = true then
     				  begin
      		  		if (theSong.Length div 1000) < dwSongNum then
	        				raise Exception.CreateFmt('G[: Ȕԍ %d ͔͈͊Oł', [dwSongNum]);
		        		theSong.SongNumber := dwSongNum;
	  		      end;

       				SingleDecoder := TAuKpiFileDecoderThread.Create(theSong, sPcmFile);
              try
      	    		dwFadeOutStart := Length;
     	  		  	if (Length < $ffffffff) and (MultiSong = false) then
	          			pbrIndivProgress.Max := Length
   				      else if (Length = $ffffffff) or MultiSong then
    	  	    	begin
	        	 	  	pbrIndivProgress.Max := Settings.DefaultLength * 1000 + Settings.FadeOutLength;
  		      	  	dwFadeOutStart := Settings.DefaultLength * 1000;
    	  		    end;
         				if (Length < $ffffffff) and (MultiSong = false) and (Loop = false) then
        			  	Fader := nil
	        	  	else
  	          		Fader := TAuKpiFader.Create(dwFadeOutStart, Settings.FadeOutLength);

       			  	with SingleDecoder do
        			  begin
  	     		  	  FreeOnTerminate := false;
	  	        		if Assigned(Fader) then Effectors.Add(Fader);
		  	        	OnProgress := OnMultiDecoderProgress;
		    	  	    OnTerminate := OnMultiDecoderTerminate;
 	  		  	  	  Title := kbmEntry.sTitle;
   	  		  	  	Artist := kbmEntry.sArtist;
                  m_bMDAborted := false;
                  m_bMultiDecoderTerminated := false;

       	  		  	Resume;
                  while not (m_bMultiDecoderTerminated or m_bMDAborted) do
                  begin
                    Application.ProcessMessages;
                    Sleep(20);
                  end;
                  if m_bMDAborted then
                  begin
                		btnStartMultiDecode.Caption := 'Jn(&S)';
               	  	AddLog('  x: fR[h̓[U̎wɂ蒆~܂');
                 		AddLog('  x: t@C͍폜܂');
                    btnSingleDecode.Enabled := true;
                    Exit;
                  end;
	    	      	end;
              finally
                SingleDecoder.Free;
              end;
 	  	    	end;    // with theSong
 	      	except    // try theSong
    	    	on E: Exception do
  	  	    begin
 		  	    	AddLog(E.Message);
  		    	  AddLog('x: fR[h͎s܂');
              Break;
 	    	  	end;
       		end;      // try theSong
        end;      // while not kbmReader.isEOF
      finally     // try kbmReader
        kbmReader.Free;
   	  	btnStartMultiDecode.Caption := 'Jn(&S)';
   		  AddLog('ꊇfR[h܂B');
        pbrIndivProgress.Position := 0;
        btnSingleDecode.Enabled := true;
      end;
    except
      on e: Exception do
      begin
 	    	AddLog(E.Message);
     	  AddLog('x: fR[h͊Jnł܂');
      end;
    end;
	end
	else
	begin
		SingleDecoder.Terminate;
    SingleDecoder.WaitFor;
    m_bMDAborted := true;
	end;
end;

procedure TfrmMain.OnMultiDecoderProgress(Song: TAuSong);
	function MSecsToString(const mSecs: DWord): string;
	begin
		Result := Format('%.2d:%.2d.%.3d', [(mSecs div 60000), (mSecs div 1000) mod 60, mSecs mod 1000]);
	end;
begin
	pbrIndivProgress.Position := Song.Position;
	lblInDivProgress.Caption := Format('%s / %s', [MSecsToString(Song.Position), MSecsToString(pbrIndivProgress.Max)]);
end;

procedure TfrmMain.OnMultiDecoderTerminate(Sender: TObject);
begin
  m_bMultiDecoderTerminated := true;
	AddLog('fR[h͊܂');
end;


end.

