unit Version;
{
 * NokomoDecoder
 * Copyright (c) 2005 Autch.net. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 
 *     Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 
 *     Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * 
 *     Neither the name of the Autch.net nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
}

{
  [Delphi] g̃o[W擾ɂ - Autch.net
  http://www.autch.net/tips/delphi_version.php
}

interface

type
	TVersion = record
		Major, Minor, Revision, Build: Cardinal;
		StringVersion, StringVersionCompressed: String;
	end;

var
	theVersion: TVersion;

implementation

uses Windows, SysUtils, Classes, Forms;

procedure LoadVersionInfo;
var
	S: string;
	n, Len: DWORD;
	Buf: PChar;
	Value: PChar;
	tsStrings: TStringList;
begin
	S := Application.ExeName;
	n := GetFileVersionInfoSize(PChar(S), n);
	if n > 0 then
	begin
		Buf := AllocMem(n);
		try
			GetFileVersionInfo(PChar(S), 0, n, Buf);
			if VerQueryValue(Buf, PChar('StringFileInfo\041103A4\FileVersion'), Pointer(Value), Len) then
			begin
				tsStrings := TStringList.Create;
				try
					ExtractStrings(['.'], [], Value, tsStrings);
					with theVersion do
					begin
						Major := StrToInt(tsStrings[0]);
						Minor := StrToInt(tsStrings[1]);
						Revision := StrToInt(tsStrings[2]);
						Build := StrToInt(tsStrings[3]);
						StringVersion := Value;
						StringVersionCompressed := Format('%d.%d.%d', [Major, Minor * 10 + Revision, Build]);
					end;
				finally
					tsStrings.Free;
				end;
			end;
		finally
			FreeMem(Buf, n);
		end;
	end
end;

initialization
	LoadVersionInfo;

end.
 