unit kpiFileDecoderThread;
{
 * NokomoDecoder
 * Copyright (c) 2005 Autch.net. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 
 *     Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 
 *     Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * 
 *     Neither the name of the Autch.net nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
}

// Pt@C̃fR[hXbh
// t@C̃fR[h𕡐ĉ񂷂ƂŎ

interface

uses
	Classes, Windows, SysUtils, KpiSong, MMSystem, Contnrs;

type
	TProgressEvent = procedure(Song: TAuSong) of object;

	TAuWavTagInfo = record
		Title, Artist: string;
	end;

	TAuKpiFileDecoderThread = class(TThread)
	private
		{ Private 錾 }
	protected
		m_Song: TAuSong;
		m_hMMIO: HMMIO;
		m_WAVEChunk, m_dataChunk: TMMCKInfo;
		FOnProgress: TProgressEvent;
		m_TagInfo: TAuWavTagInfo;
		m_Effectors: TObjectList;
		m_bDeleteOutput: Boolean;
		m_FileName: TFileName;

		procedure Execute; override;
		procedure RunProgressEvent;
	public
		constructor Create(aSong: TAuSong; PCMfilename: TFileName);
		destructor Destroy; override;

		property Title: string read m_TagInfo.Title write m_tagInfo.Title;
		property Artist: string read m_TagInfo.Artist write m_tagInfo.Artist;
		property OnProgress: TProgressEvent read FOnProgress write FOnProgress;
		property Effectors: TObjectList read m_Effectors write m_Effectors;
	end;

implementation

{:
	قȂXbhL VCL ܂ CLX ̃\bh/֐/
	vpeBʂ̃Xbh̒爵ꍇAr̖肪
	܂B

	CXbh̏LIuWFNgɑ΂Ă Synchronize
	\bhgł܂B̃IuWFNgQƂ邽
	̃\bhXbhNXɒǉASynchronize \bh
	Ƃēn܂B

	Ƃ΁AUpdateCaption \bhȉ̂悤ɒ`A

		procedure TAuKpiFileDecoderThread.UpdateCaption;
		begin
			Form1.Caption := 'TAuKpiFileDecoderThread Xbh珑܂';
		end;

	Execute \bh̒ Synchronize \bhɓnƂŃC
	XbhL Form1  Caption vpeBSɕ
	Xł܂B

			Synchronize(UpdateCaption);
}

{ TAuKpiFileDecoderThread }

uses kpiEffector, ComObj;

procedure TAuKpiFileDecoderThread.Execute;
var
	buffer: PByte;
	dwSize, dwUnitSize: DWord;
	LISTchunk: TMMCKInfo;
	TagChunk: TMMCKInfo;
	dwOldPos: DWord;
	i: integer;
begin
	try
    // dwUnitRender ƁA񕪂̃fR[hɎgobt@TCY߂
		dwUnitSize := m_Song.UnitRender;
		if dwUnitSize = 0 then dwUnitSize := 8192;
		GetMem(buffer, dwUnitSize);

		try
			dwOldPos := m_Song.Position;
			repeat
        // vOC PCM 擾
				dwSize := m_Song.Render(buffer, dwUnitSize);

        // GtFN^ɏԂɒʂ
				for i := 0 to m_Effectors.Count - 1 do
					if m_Effectors.Items[i] is TAuKpiEffector then
						dwSize := (m_Effectors.Items[i] as TAuKpiEffector).DoEffect(m_Song, buffer, dwSize);

        // fBXNɏ
				mmioWrite(m_hMMIO, PChar(buffer), dwSize);

        // vOXXV
				if Assigned(@FOnProgress) and (abs(m_Song.Position - dwOldPos) > 1000(*500*)) then
				begin
					Synchronize(RunProgressEvent);
					dwOldPos := m_Song.Position;
				end;
				Sleep(0);
			until m_Song.EndFlag or Terminated or (dwSize < dwUnitSize);
			if Terminated then
			begin
				// fR[hf
				m_bDeleteOutput := true;
			end;
			if Assigned(@FOnProgress) then
				Synchronize(RunProgressEvent);
		finally
			FreeMem(buffer);
		end;
	finally
    // RIFF t@Čn
    mmioFlush(m_hmmio, 0);
		mmioAscend(m_hmmio, @m_dataChunk, 0);

    // ^CgA[eBXgݒ肳Ă
    if Length(m_TagInfo.Title) + Length(m_TagInfo.Artist) > 0 then
    begin
      // RIFF LIST `Nɏ
  		ZeroMemory(@LISTChunk, SizeOf(TMMCKInfo));
	  	LISTChunk.ckid := mmioStringToFOURCC('LIST', 0);
		  LISTChunk.fccType := mmioStringToFOURCC('INFO', 0);
  		LISTChunk.cksize := 0;
	  	mmioCreateChunk(m_hMMIO, @LISTChunk, MMIO_CREATELIST);

      if Length(m_TagInfo.Title) > 0 then
      begin
    		ZeroMemory(@TagChunk, SizeOf(TMMCKInfo));
	    	TagChunk.ckid := mmioStringToFOURCC('INAM', 0);
		    TagChunk.cksize := 0;
    		mmioCreateChunk(m_hMMIO, @TagChunk, 0);
	    	mmioWrite(m_hMMIO, PChar(m_TagInfo.Title), Length(m_TagInfo.Title));
		    mmioAscend(m_hMMIO, @TagChunk, 0);
      end;

      if Length(m_TagInfo.Artist) > 0 then
      begin
    		ZeroMemory(@TagChunk, SizeOf(TMMCKInfo));
	    	TagChunk.ckid := mmioStringToFOURCC('IART', 0);
		    TagChunk.cksize := 0;
  		  mmioCreateChunk(m_hMMIO, @TagChunk, 0);
  	  	mmioWrite(m_hMMIO, PChar(m_TagInfo.Artist), Length(m_TagInfo.Artist));
	  	  mmioAscend(m_hMMIO, @TagChunk, 0);
      end;

  		mmioAscend(m_hmmio, @LISTChunk, 0);
    end;

		mmioAscend(m_hmmio, @m_WAVEChunk, 0);
	end;
end;

procedure TAuKpiFileDecoderThread.RunProgressEvent;
begin
	FOnProgress(m_Song);
end;

constructor TAuKpiFileDecoderThread.Create(aSong: TAuSong; PCMfilename: TFileName);
var
	wfEx: TWaveFormatEx;
begin
	inherited Create(true);

	m_FileName := PCMfilename;
	m_Effectors := TObjectList.Create(true);
	m_Song := aSong;
	begin // 2005.11.19: Ȃł begin ccǂRsyĂ񂾂낤
		ZeroMemory(@wfEx, SizeOf(TWaveFormatEx));
    // WaveAudio t@Cwb_[̏
		with wfEx do
		begin
			cbSize := 0;
			wFormatTag := WAVE_FORMAT_PCM;
			nSamplesPerSec := m_Song.SamplesPerSec;
			wBitsPerSample := m_Song.BitsPerSample;
			nChannels := m_Song.Channels;
			nAvgBytesPerSec := (wfex.wBitsPerSample shr 3) * wfex.nChannels * wfex.nSamplesPerSec;
			nBlockAlign := (wfex.wBitsPerSample shr 3) * wfex.nChannels;
		end;
    // RIFF t@CJ WaveAudio wb_
		m_hMMIO := mmioOpen(PChar(PCMfilename), nil, MMIO_CREATE or MMIO_WRITE);
		if m_hMMIO = 0 then
			raise Exception.CreateFmt('G[: Wav t@C %s 쐬ł܂ł', [PCMfilename]);
		ZeroMemory(@m_WAVEChunk, SizeOf(TMMCKInfo));
		ZeroMemory(@m_dataChunk, SizeOf(TMMCKInfo));

		m_WAVEChunk.fccType := mmioStringToFOURCC('WAVE', 0);
		mmioCreateChunk(m_hMMIO, @m_WAVEChunk, MMIO_CREATERIFF);

		m_dataChunk.ckid := mmioStringToFOURCC('fmt ', 0);
		m_dataChunk.cksize := SizeOf(TWaveFormatEx);
		mmioCreateChunk(m_hMMIO, @m_dataChunk, 0);

		mmioWrite(m_hMMIO, @wfex, SizeOf(TWaveFormatEx));
		mmioAscend(m_hMMIO, @m_dataChunk, 0);

		m_dataChunk.ckid := mmioStringToFOURCC('data', 0);
		m_dataChunk.cksize := 0;
		mmioCreateChunk(m_hMMIO, @m_dataChunk, 0);
	end;
end;

destructor TAuKpiFileDecoderThread.Destroy;
begin
	if m_hMMIO <> 0 then
	begin
		mmioFlush(m_hMMIO, 0);
		mmioClose(m_hMMIO, 0);
		if m_bDeleteOutput then
			DeleteFile(m_FileName);
	end;
	m_Song.Free;
	m_Effectors.Free;

	inherited;
end;

end.
